/*****************************************************************************
 * Client-Server communication using AF_UNIX sockets
 * This is client
 *
 * Algorithm:
 * 1. make an communication endpoint - socket()
 * 2. connection to the socket - connect() (socket must exist already)
 * 3. write data to the socket (character A)
 * 4. read data from socket (character B)
 ****************************************************************************/

#include <sys/types.h>
#include <sys/socket.h>
#include <stdio.h>
#include <sys/un.h>
#include <unistd.h>

int
main ()
{
  int sockfd;
  int len;
  struct sockaddr_un address;
  int result;
  char ch = 'A';		// char which will be send to server 

  sockfd = socket (AF_UNIX, SOCK_STREAM, 0);

  address.sun_family = AF_UNIX;
  strcpy (address.sun_path, "socket_ahoj");	// make socket in actual directory 
  /* strcpy (address.sun_path, "/tmp/socket_ahoj"); */

  len = sizeof (address);

  result = connect (sockfd, (struct sockaddr *) &address, len);

  if (result == -1)
    {
      perror ("server is not running");
      exit (1);
    }

  printf ("klient: char for server \"%c\"\n", ch);
  write (sockfd, &ch, 1);	// write to socket 1 byte
  read (sockfd, &ch, 1);	// read from socket 1 byte
  printf ("klient: char from server: \"%c\"\n", ch);
  close (sockfd);
  exit (0);
}
