/*****************************************************************************
 * Client-Server communication using AF_UNIX sockets
 * This is server
 * 
 * Algorithm:
 * 1. make an communication endpoint - socket()
 * 2. name the socket - bind()
 * 3. set the connection acceptance and front size - listen()
 * 4. accept the connections - accept()
 * 5. read data from socket - read()
 * 6. write data to socket - write()
 * 7. close the socket - close()
 * ***************************************************************************/

#include <sys/types.h>
#include <sys/socket.h>
#include <stdio.h>
#include <sys/un.h>
#include <unistd.h>

#define SOCK_NAME "socket_ahoj"	// it's possible to provide absolute path here 

int
main ()
{
  int server_sockfd, client_sockfd;
  int server_len, client_len, i, result;
  struct sockaddr_un server_address, client_address;

  result = unlink (SOCK_NAME);	// delete the name and the file it refers to 
  server_sockfd = socket (AF_UNIX, SOCK_STREAM, 0);

  server_address.sun_family = AF_UNIX;
  /* strcpy (server_address.sun_path, "/tmp/socket_ahoj"); */
  strcpy (server_address.sun_path, SOCK_NAME);

  server_len = sizeof (server_address);
  bind (server_sockfd, (struct sockaddr *) &server_address, server_len);

  listen (server_sockfd, 5);	/* max. 5 connections */
  i = 5;
  while (i > 0)
    {
      char ch;
      printf ("server: waiting\n");
      client_len = sizeof (client_address);
      client_sockfd =
	accept (server_sockfd, (struct sockaddr *) &client_address,
		&client_len);
      read (client_sockfd, &ch, 1);
      printf("Char from client: \"%c\"\n", ch);
      ch++;
      write (client_sockfd, &ch, 1);
      printf("Char to client: \"%c\"\n", ch);
      close (client_sockfd);
      i--;
    }
}
